﻿using DevExpress.ExpressApp.DC;
using DevExpress.Persistent.Base;
using DevExpress.Persistent.BaseImpl;
using DevExpress.Xpo;
using DevExpress.Xpo.Metadata;
using System.Drawing;

namespace TestSolutionForCardLEd.Module.BusinessObjects
{
    [DomainComponent, DefaultClassOptions]
    public class StPreparedFormExportTypes : BaseObject
    {
        public StPreparedFormExportTypes(Session session) : base(session) { }

        private string _type;
        private string _description;
        private string _extension;

        [XafDisplayName("Type")]
        [DevExpress.Persistent.Base.ImmediatePostDataAttribute] 
        public System.String ExportType
        {
            get { return _type; }
            set { SetPropertyValue("ExportType", ref _type, value); }
        }

        [XafDisplayNameAttribute("Description")] 
        public string Description
        {
            get { return _description; }
            set { SetPropertyValue("Description", ref _description, value); }
        }

        [Delayed, ValueConverter(typeof(ImageValueConverter))]
        [DevExpress.ExpressApp.DC.XafDisplayNameAttribute("Image")]
        public Image Icon
        {
            get { return GetDelayedPropertyValue<Image>("Icon"); }
            set { SetDelayedPropertyValue("Icon", value); }
        }

        [XafDisplayName("Extension")]
        [DevExpress.Persistent.Base.ImmediatePostDataAttribute]
        [DevExpress.Persistent.Base.VisibleInListViewAttribute(false)]
        [DevExpress.Persistent.Base.VisibleInDetailViewAttribute(true)]
        public System.String Extension
        {
            get { return _extension; }
            set { SetPropertyValue("Extension", ref _extension, value); }
        }
    }
}
