using System;
using DevExpress.ExpressApp;
using DevExpress.ExpressApp.Updating;
using TestSolutionForCardLEd.Module.BusinessObjects;

namespace TestSolutionForCardLEd.Module.DatabaseUpdate
{
    // For more typical usage scenarios, be sure to check out http://documentation.devexpress.com/#Xaf/clsDevExpressExpressAppUpdatingModuleUpdatertopic
    public class Updater : ModuleUpdater
    {
        public Updater(IObjectSpace objectSpace, Version currentDBVersion) :
            base(objectSpace, currentDBVersion)
        {
        }
        public override void UpdateDatabaseAfterUpdateSchema()
        {
            base.UpdateDatabaseAfterUpdateSchema();
            CreateCardListEditorObjects();

            ObjectSpace.CommitChanges();
        }
       
        private void CreateCardListEditorObjects()
        {
            if (ObjectSpace.GetObjects<StPreparedFormExportTypes>().Count != 0)
                return;
            var obj1 = ObjectSpace.CreateObject<StPreparedFormExportTypes>();
            obj1.Description = "Step 1";
            obj1.ExportType = "ExportType";
            obj1.Icon = Properties.Resources.Step1;

            var obj2 = ObjectSpace.CreateObject<StPreparedFormExportTypes>();
            obj2.Description = "Step 2";
            obj2.ExportType = "ExportType";
            obj2.Icon = Properties.Resources.Step2;

            var obj3 = ObjectSpace.CreateObject<StPreparedFormExportTypes>();
            obj3.Description = "Step 3";
            obj3.ExportType = "ExportType";
            obj3.Icon = Properties.Resources.Step3;
            }
    }
}
