﻿using System;
using System.IO;
using System.Web.UI;
using DevExpress.ExpressApp.DC;
using DevExpress.ExpressApp.Web;
using DevExpress.ExpressApp.Web.Templates;
using Xafari.Editors.Web;
using Xafari.Editors.Web.Model;
using Image = System.Drawing.Image;

namespace TestSolutionForCardLEd.Web.Templates
{
    public partial class CardListEditorTemplateBase : UserControl, ICardTemplate
    {
        internal ASPxCardListEditorControl Control { get; set; }
        internal Object CurrentObject { get; set; }
        internal IModelCardListEditor Model { get; set; }
        internal XafCallbackManager CallbackManager { get { return Page != null ? ((ICallbackManagerHolder)Page).CallbackManager : null; } }
        protected int CustomImageWidth { get; set; }
        protected int CustomImageHeight { get; set; }
        protected int Count { get; set; }
        protected int CurrentObjectID { get; set; }
        protected Position PositionOnPage { get; set; }
        protected IMemberInfo KeyMember;

        public void SetupCurrentObject(object control, object currentObject, int currentObjectID, int count, Position positionOnPage, IMemberInfo keyMember)
        {
            Control = (ASPxCardListEditorControl)control;
            CurrentObject = currentObject;
            CurrentObjectID = currentObjectID;
            Count = count;
            PositionOnPage = positionOnPage;
            Model = Control.CardListViewModel;
            KeyMember = keyMember;
        }

        protected string GetImageUrl(Image image) { return image == null ? string.Empty : ImageResourceHttpHandler.GetWebResourceUrl("IC_" + WebImageHelper.GetImageHash(image)); }

        protected string GetOnclickScript() { return CallbackManager != null ? CallbackManager.GetScript(Control.UniqueID, string.Format("'{0}'", KeyMember.GetValue(CurrentObject))) : String.Empty; }

        protected byte[] GetImageByteArray(Image image)
        {
            var ms = new MemoryStream();
            if (image != null)
            {
                //Раскомментировать если будем использовать кастомные размеры картинки
                //image = image.GetThumbnailImage(CustomImageWidth, CustomImageHeight, () => true, IntPtr.Zero);
                image.Save(ms, System.Drawing.Imaging.ImageFormat.Png);
            }
            return ms.ToArray();
        }
       
        protected T GetCurrentObject<T>() { return (T)CurrentObject; }
    }

    enum LeadingProperty
    {
        Width,
        Height,
        Unassigned
    }
}
