using System;
using DevExpress.ExpressApp;
using System.ComponentModel;
using DevExpress.ExpressApp.Xpo;
using DevExpress.ExpressApp.Web;
using System.Collections.Generic;
//using DevExpress.ExpressApp.Security;

namespace TestSolutionForCardLEd.Web
{
    // For more typical usage scenarios, be sure to check out http://documentation.devexpress.com/#Xaf/DevExpressExpressAppWebWebApplicationMembersTopicAll
    public partial class TestSolutionForCardLEdAspNetApplication : WebApplication
    {
        private DevExpress.ExpressApp.SystemModule.SystemModule module1;
        private DevExpress.ExpressApp.Web.SystemModule.SystemAspNetModule module2;
        private TestSolutionForCardLEd.Module.TestSolutionForCardLEdModule module3;
        private Xafari.Web.XafariWebModule xafariWebModule1;
        private DevExpress.ExpressApp.ConditionalAppearance.ConditionalAppearanceModule conditionalAppearanceModule1;
        private Xafari.XafariModule xafariModule1;
        private Xafari.Editors.Web.XafariEditorsWebModule xafariEditorsWebModule1;
        private Xafari.Editors.XafariEditorsModule xafariEditorsModule1;
        private DevExpress.ExpressApp.TreeListEditors.TreeListEditorsModuleBase treeListEditorsModuleBase1;
        private DevExpress.ExpressApp.TreeListEditors.Web.TreeListEditorsAspNetModule treeListEditorsAspNetModule1;
        private TestSolutionForCardLEd.Module.Web.TestSolutionForCardLEdAspNetModule module4;

        public TestSolutionForCardLEdAspNetApplication()
        {
            InitializeComponent();
        }
        protected override void CreateDefaultObjectSpaceProvider(CreateCustomObjectSpaceProviderEventArgs args)
        {
            args.ObjectSpaceProvider = new XPObjectSpaceProvider(args.ConnectionString, args.Connection, true);
        }

        private void TestSolutionForCardLEdAspNetApplication_DatabaseVersionMismatch(object sender, DevExpress.ExpressApp.DatabaseVersionMismatchEventArgs e)
        {
#if EASYTEST
            e.Updater.Update();
            e.Handled = true;
#else
            if (System.Diagnostics.Debugger.IsAttached)
            {
                e.Updater.Update();
                e.Handled = true;
            }
            else
            {
                string message = "The application cannot connect to the specified database, because the latter doesn't exist or its version is older than that of the application.\r\n" +
                    "This error occurred  because the automatic database update was disabled when the application was started without debugging.\r\n" +
                    "To avoid this error, you should either start the application under Visual Studio in debug mode, or modify the " +
                    "source code of the 'DatabaseVersionMismatch' event handler to enable automatic database update, " +
                    "or manually create a database using the 'DBUpdater' tool.\r\n" +
                    "Anyway, refer to the following help topics for more detailed information:\r\n" +
                    "'Update Application and Database Versions' at http://www.devexpress.com/Help/?document=ExpressApp/CustomDocument2795.htm\r\n" +
                    "'Database Security References' at http://www.devexpress.com/Help/?document=ExpressApp/CustomDocument3237.htm\r\n" +
                    "If this doesn't help, please contact our Support Team at http://www.devexpress.com/Support/Center/";

                if (e.CompatibilityError != null && e.CompatibilityError.Exception != null)
                {
                    message += "\r\n\r\nInner exception: " + e.CompatibilityError.Exception.Message;
                }
                throw new InvalidOperationException(message);
            }
#endif
        }

        private void InitializeComponent()
        {
            this.module1 = new DevExpress.ExpressApp.SystemModule.SystemModule();
            this.module2 = new DevExpress.ExpressApp.Web.SystemModule.SystemAspNetModule();
            this.module3 = new TestSolutionForCardLEd.Module.TestSolutionForCardLEdModule();
            this.module4 = new TestSolutionForCardLEd.Module.Web.TestSolutionForCardLEdAspNetModule();
            this.xafariWebModule1 = new Xafari.Web.XafariWebModule();
            this.conditionalAppearanceModule1 = new DevExpress.ExpressApp.ConditionalAppearance.ConditionalAppearanceModule();
            this.xafariModule1 = new Xafari.XafariModule();
            this.xafariEditorsWebModule1 = new Xafari.Editors.Web.XafariEditorsWebModule();
            this.xafariEditorsModule1 = new Xafari.Editors.XafariEditorsModule();
            this.treeListEditorsModuleBase1 = new DevExpress.ExpressApp.TreeListEditors.TreeListEditorsModuleBase();
            this.treeListEditorsAspNetModule1 = new DevExpress.ExpressApp.TreeListEditors.Web.TreeListEditorsAspNetModule();
            ((System.ComponentModel.ISupportInitialize)(this)).BeginInit();
            // 
            // xafariWebModule1
            // 
            this.xafariWebModule1.ResourcesExportedToModel.Add(typeof(DevExpress.ExpressApp.Web.Localization.ASPxGridViewControlLocalizer));
            this.xafariWebModule1.ResourcesExportedToModel.Add(typeof(DevExpress.ExpressApp.Web.Localization.ASPxGridViewResourceLocalizer));
            this.xafariWebModule1.ResourcesExportedToModel.Add(typeof(DevExpress.ExpressApp.Web.Localization.ASPxGridViewControlLocalizer));
            this.xafariWebModule1.ResourcesExportedToModel.Add(typeof(DevExpress.ExpressApp.Web.Localization.ASPxGridViewResourceLocalizer));
            // 
            // TestSolutionForCardLEdAspNetApplication
            // 
            this.ApplicationName = "TestSolutionForCardLEd";
            this.Modules.Add(this.module1);
            this.Modules.Add(this.module2);
            this.Modules.Add(this.conditionalAppearanceModule1);
            this.Modules.Add(this.xafariModule1);
            this.Modules.Add(this.module3);
            this.Modules.Add(this.module4);
            this.Modules.Add(this.xafariWebModule1);
            this.Modules.Add(this.xafariEditorsModule1);
            this.Modules.Add(this.treeListEditorsModuleBase1);
            this.Modules.Add(this.treeListEditorsAspNetModule1);
            this.Modules.Add(this.xafariEditorsWebModule1);
            this.DatabaseVersionMismatch += new System.EventHandler<DevExpress.ExpressApp.DatabaseVersionMismatchEventArgs>(this.TestSolutionForCardLEdAspNetApplication_DatabaseVersionMismatch);
            ((System.ComponentModel.ISupportInitialize)(this)).EndInit();

        }
    }
}
